import 'package:bloc_stream/bloc_stream.dart';
import 'package:riverpod/riverpod.dart';

import 'bloc_stream_provider.dart';

class BlocStreamProviderFamilyBuilder {
  const BlocStreamProviderFamilyBuilder();

  BlocStreamProviderFamily<T, Value> call<T extends BlocStream<Object?>, Value>(
    T Function(ProviderReference ref, Value value) create, {
    String? name,
  }) {
    return BlocStreamProviderFamily(create, name: name);
  }

  AutoDisposeBlocStreamProviderFamilyBuilder get autoDispose {
    return const AutoDisposeBlocStreamProviderFamilyBuilder();
  }
}

class AutoDisposeBlocStreamProviderBuilder {
  const AutoDisposeBlocStreamProviderBuilder();

  AutoDisposeBlocStreamProvider<T> call<T extends BlocStream<Object?>>(
    T Function(AutoDisposeProviderReference ref) create, {
    String? name,
  }) {
    return AutoDisposeBlocStreamProvider(create, name: name);
  }

  AutoDisposeBlocStreamProviderFamilyBuilder get family {
    return const AutoDisposeBlocStreamProviderFamilyBuilder();
  }
}

/// Builds a [AutoDisposeBlocStreamProviderFamily].
class AutoDisposeBlocStreamProviderFamilyBuilder {
  /// Builds a [AutoDisposeBlocStreamProviderFamily].
  const AutoDisposeBlocStreamProviderFamilyBuilder();

  AutoDisposeBlocStreamProviderFamily<T, Value>
      call<T extends BlocStream<Object?>, Value>(
    T Function(AutoDisposeProviderReference ref, Value value) create, {
    String? name,
  }) {
    return AutoDisposeBlocStreamProviderFamily(create, name: name);
  }
}
